<?php
/*
  PhotoFXPlus.com Added: Subscription Products
  Editing by Lloyd Peck webmaster at photofxplus.com
  http://photofxplus.com Nov. 07

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2003 osCommerce

  Released under the GNU General Public License
*/

// Include language translations
  require(DIR_WS_LANGUAGES . 'english/modules/payment/subscription_payments.php');
  
  class subscription_product
  {
    var $enabled, $code, $info, $download, $product, $status, $dwnld_text;

// class constructor
    function subscription_product($product_id = '')
    {	
    	if (defined(MODULE_PAYMENT_SUBSCRIPTION_PAYMENTS_STATUS) && MODULE_PAYMENT_SUBSCRIPTION_PAYMENTS_STATUS == true)
    	{  
    		$this->enabled = true;  
	      $this->code = 'subscription';
				$this->info = array();
				
	      if (!tep_not_null($product_id) || !is_numeric($product_id))
	      {
// Fetch product id from customers cart or order
// Value sent with variable $product_id is intended to be uprid(products_id w/attributes) 
 	        $product_id = $this->get_prodID($product_id);
	      }
	      
	      if (tep_not_null($product_id) and is_numeric($product_id))
	      {
	        $product_id = tep_db_prepare_input($product_id);
		      $this->query($product_id);
					$this->download = $this->confirm_download();
					$this->product = $this->confirm_sub_prod();
					$this->status = $this->sub_text();
					$this->dwnld_text = $this->dwnld_text();
		    }
			}
			else
			{	$this->enabled = false;
			}
		}

// class methods
		function query($product_id)
		{	global $customer_id, $languages_id;

// Retrieve category_id for product if product is in subscription category
			$cat_id_query = tep_db_query("select cd.categories_id as id from " . TABLE_CATEGORIES_DESCRIPTION . " cd, " . TABLE_PRODUCTS_TO_CATEGORIES . " p2c where p2c.products_id = '" . (int)$product_id . "' and cd.categories_id = p2c.categories_id and cd.language_id = '" . (int)$languages_id . "' and cd.subscription_category = '1' limit 1");
			
			if (tep_db_num_rows($cat_id_query))
			{	$category = tep_db_fetch_array($cat_id_query);
			
// Check if product is the product subscription for the category (prod_sub)
				$check_query = tep_db_query("select count(*) as total from " . TABLE_PRODUCTS_ATTRIBUTES . " pa, " . TABLE_PRODUCTS_ATTRIBUTES_DOWNLOAD . " pad where pa.products_id = '" . (int)$product_id . "' and pad.products_attributes_id = pa.products_attributes_id and pad.product_subscription = '1' limit 1");

// Retrieve product subscription values
				$info_query = tep_db_query("select pad.products_attributes_maxcount, pad.products_attributes_maxdays from " . TABLE_PRODUCTS_TO_CATEGORIES . " p2c, " . TABLE_PRODUCTS_ATTRIBUTES . " pa, " . TABLE_PRODUCTS_ATTRIBUTES_DOWNLOAD . " pad where p2c.categories_id = '" . (int)$category['id'] . "' and pa.products_id = p2c.products_id and pad.products_attributes_id = pa.products_attributes_id and pad.product_subscription = '1' limit 1");
				
// If subscription has been purchased - retrieve subscription status
				$status_query = tep_db_query("select o.orders_status, date_format(o.date_purchased, '%Y-%m-%d' ) as date_purchased_day from " . TABLE_ORDERS  . " o, " . TABLE_ORDERS_PRODUCTS . " op, " . TABLE_PRODUCTS_TO_CATEGORIES . " p2c, " . TABLE_PRODUCTS_ATTRIBUTES . " pa, " . TABLE_PRODUCTS_ATTRIBUTES_DOWNLOAD . " pad where o.customers_id = '" . (int)$customer_id . "' and op.orders_id = o.orders_id and op.products_id = p2c.products_id and p2c.categories_id = '" . (int)$category['id'] . "' and pa.products_id = p2c.products_id and pad.products_attributes_id = pa.products_attributes_id and pad.product_subscription = '1' order by o.date_purchased desc limit 1");
			
		    $check = tep_db_fetch_array($check_query);
		    if ($check['total'] == 1)
				{	$this->info['prod_sub'] = 'true';
				}
					
				if (tep_db_num_rows($info_query) == 1)
				{	$info = tep_db_fetch_array($info_query);
					$this->info['sub_prod'] = 'true';
					$this->info['maxCount'] = $info['products_attributes_maxcount'];
					$this->info['maxDays'] = $info['products_attributes_maxdays'];
					$this->info['ttl_dwnlds'] = $this->sub_download_ct($category['id']);
					
					if ((int)$this->info['ttl_dwnlds'] >= (int)$this->info['maxCount'])
					{	
						$this->info['dwnld_count'] = 'exceeded';
					}	
					
// Set now timestamp			
					$now_date = date("Y-m-d");
					list($dt_year, $dt_month, $dt_day) = explode('-', $now_date);
					$this->info['now_ts'] = mktime(00, 00, 01, $dt_month, $dt_day, $dt_year, -1);
										
					if (tep_db_num_rows($status_query))
					{	$status = tep_db_fetch_array($status_query);
						
// Set customer subscription purchase and expiration timestamps
						list($dt_year, $dt_month, $dt_day) = explode('-', $status['date_purchased_day']);
						$this->info['purchase_ts'] = mktime(23, 59, 59, $dt_month, $dt_day, $dt_year, -1);
						$this->info['expiry_ts'] = mktime(23, 59, 59, $dt_month, $dt_day + $this->info['maxDays'], $dt_year, -1);
	
						$this->info['orders_status'] = $status['orders_status'];
						$this->info['sub_status'] = $this->sub_status();
					}
				}
			}
			return $this->info;
		}

// Determine subscription account status		
		function sub_status($result = '')
		{
			if ($this->info['expiry_ts'] > $this->info['now_ts'] && $this->info['orders_status'] == (int)MODULE_PAYMENT_PAYPAL_IPN_COMP_ORDER_STATUS_ID)
			{	
				$result = 'current';
			}
			elseif ($this->info['expiry_ts'] < $this->info['now_ts'])
			{	
				$result = 'expired';
			}
			elseif ( !($this->info['orders_status'] == (int)MODULE_PAYMENT_PAYPAL_IPN_COMP_ORDER_STATUS_ID) )
			{	
				$result = 'onhold';
			}
			return $result;
		}

// Determine if customers free downloads exceeds max 		
		function sub_download_ct($categories_id, $result = '')
		{	global $customer_id;
		
			$downloads_query = tep_db_query("select opd.download_count from " . TABLE_ORDERS . " o, " . TABLE_ORDERS_PRODUCTS_DOWNLOAD . " opd, " . TABLE_ORDERS_PRODUCTS . " op, " . TABLE_PRODUCTS_TO_CATEGORIES . " p2c where o.customers_id = '" . (int)$customer_id . "' and opd.orders_id = o.orders_id and op.orders_id = opd.orders_id and p2c.products_id = op.products_id and p2c.categories_id = '" . (int)$categories_id . "'");
	
			if (tep_db_num_rows($downloads_query))
			{	$ct = 0;
				while ($dwnld_array = tep_db_fetch_array($downloads_query))
				{	$dwnld_ct = $this->info['maxCount'] - $dwnld_array['download_count'];
					$ct = $dwnld_ct + $ct;
				}
				$result = $ct;
			}
			return $result;
		}

// Get product_id in customers cart	or order	
		function get_prodID($uprid)
		{	global $HTTP_GET_VARS, $cart, $customer_id;
			$product_id = '';
			
			if ( (strstr($uprid, '{')) )
	  	{	$product_id = tep_get_prid($uprid);
	  	}
	  	
			elseif (isset($HTTP_GET_VARS['order_id']))
			{ $order_id = $HTTP_GET_VARS['order_id'];
		  }

	  	elseif (isset($cart) && is_object($cart) && $cart->count_contents() == 1)
	  	{	$products = $cart->get_products();
		  	{	$product_id = tep_get_prid($products[0]['id']);
		  	}
		  }	
	
		  else
		  { $orders_query = tep_db_query("select orders_id from " . TABLE_ORDERS . " where customers_id = '" . (int)$customer_id . "' order by orders_id desc limit 1");
		    $orders = tep_db_fetch_array($orders_query);
		    $order_id = $orders['orders_id'];
		  }
		  
		  if (isset($order_id) && is_numeric($order_id))
		  {	$id_query = tep_db_query("select products_id from " . TABLE_ORDERS_PRODUCTS . " where orders_id = '" . (int)$order_id . "'");
		  	$id_array = tep_db_fetch_array($id_query);
		  	$product_id = $id_array['products_id'];
		  }
		  return $product_id;
		}

// Confirm product is subscription product and can be downloaded according to account status		
		function confirm_download($result = '' )
		{
			if ( (($this->info['sub_prod'] == 'true') && !($this->info['prod_sub'] == 'true')) && (($this->info['sub_status'] == 'current') || !($this->info['dwnld_count'] == 'exceeded')) )
			{
				$result = 'true';
			}
			else
			{
				$result = 'false';
			}	
			return $result;
		}

// Confirm product is subsription product and not product subscription		
		function confirm_sub_prod($result = 'false')
		{
			if ( ($this->info['sub_prod'] == 'true') && !($this->info['prod_sub'] == 'true') )
			{
				$result = 'true';
			}
			else
			{
				$result = 'false';
			}	
			return $result;
		}

		
// Initialize displayed text for subscription status		
		function sub_text()
		{	
		  
			$result = array();
			switch ($this->info['sub_status'])
			{	
				case 'current':
					$result['expiry_date'] = tep_date_long(date('Y-m-d H:i:s', $this->info['expiry_ts']));
					$result['dys_remaining'] = round( ($this->info['expiry_ts'] - $this->info['now_ts']) /86400 );
					$result['text1'] = $result['dys_remaining'] . '&nbsp;Days Remaining';
					$result['text2'] = FX_TY_SUBSCRIPTION_PURCHASE;
					break;
					
				case 'expired':
					$result['expiry_date'] = tep_date_long(date('Y-m-d H:i:s', $this->info['expiry_ts']));
					$result['dys_remaining'] = '0';
					$result['text1'] = FX_EXPIRED_SUBSCRIPTION;
					$result['text2'] = FX_MAX_OF . $this->info['maxDays'] . FX_SUB_NUM_FREE_DOWNLOADS;
					break;
					
				case 'onhold':
					$result['expiry_date'] = FX_NULL_EXPIRY_DATE;
					$result['dys_remaining'] = '0';
					$result['text1'] = FX_PAYMENT_PENDING;
					$result['text2'] = FX_PAYMENT_PENDING_DESC;
					break;
					
				default:
					$result['expiry_date'] = FX_NULL_EXPIRY_DATE;
					$result['dys_remaining'] = '0';
					$result['text1'] = FX_NO_SUBSCRIPTION;
					$result['text2'] = FX_MAX_OF . $this->info['maxCount'] . FX_ACC_NUM_FREE_DOWNLOADS;
					break;
			}
			return $result;
		}

// Initialize displayed text for download status
		function dwnld_text()
		{
		  
			$result = array();	
// Product is subscription purchase			
			if ($this->info['prod_sub'] == 'true')
			{	$result['download_product'] = 'false';
				$result['text1'] = FX_SUBSCRIPTION;
				$result['text2'] = FX_MAX_OF . $this->info['maxDays'] . FX_SUB_NUM_FREE_DOWNLOADS;
				$result['text3'] = FX_TTL_DOWNLOADS . $this->info['ttl_dwnlds'] . '<br>(' . $this->info['maxCount'] . FX_ACC_NUM_FREE_DOWNLOADS . ')';
			}
			
// A current subcription does not exist and free downloads count has been exceeded					
			elseif (!($this->info['sub_status'] == 'current') && ($this->info['dwnld_count'] == 'exceeded'))
			{	$result['download_product'] = 'false';
				$result['text1'] = FX_SUBSCRIPTION_PRODUCT . '<br>' . FX_BGN_FONT . '&nbsp;&nbsp;' . $downloads['products_name'] . FX_END_FONT;
				$result['text2'] = FX_MAX_DWNLDS;
				$result['text3'] = FX_TTL_DOWNLOADS . $this->info['ttl_dwnlds'] . '<br>(' . $this->info['maxCount'] . FX_ACC_NUM_FREE_DOWNLOADS . ')';
			}
			
// A current subscription does not exist and free downloads has not been exceeded					
			elseif (!($this->info['sub_status'] == 'current') && !($this->info['dwnld_count'] == 'exceeded'))
			{	$result['download_product'] = 'true';
				$result['text1'] = FX_SUBSCRIPTION_PRODUCT . '<br>' . FX_BGN_FONT . '&nbsp;&nbsp;' . $downloads['products_name'] . FX_END_FONT;
				$result['text2'] = FX_TTL_DOWNLOADS . $this->info['ttl_dwnlds'] . '<br>(' . $this->info['maxCount'] . FX_ACC_NUM_FREE_DOWNLOADS . ')';
				$result['text3'] = '&nbsp;';
			}
			
// A current subscription exists and free downloads count has been exceeded
			elseif ($this->info['sub_status'] == 'current' && $this->info['dwnld_count'] == 'exceeded')
			{	$result['download_product'] = 'true';
				$result['text1'] = FX_SUBSCRIPTION_PRODUCT . '<br>' . FX_BGN_FONT . '&nbsp;&nbsp;' . $downloads['products_name'] . FX_END_FONT;
				$result['text2'] = FX_DWNLD_AVAILABLE;
				$result['text3'] = '&nbsp;';
			}
			return $result;
		}
				
		function pre_confirmation_check()
		{
			$error ='';
			
			if ($this->info['sub_prod'] == 'true')
			{					
				if ($this->info['prod_sub'] == 'true' && $this->info['sub_status'] == 'current')
				{ $error = 'current_sub';
				}
				elseif ($this->info['prod_sub'] != 'true' && $this->info['sub_status'] != 'current' && $this->info['dwnld_count'] == 'exceeded')
				{	$error = 'exceeded';
				}
				elseif ($this->info['prod_sub'] == 'true' && !($this->info['dwnld_count'] == 'exceeded'))
				{ $error = 'dwnld_free';
				}
				if (tep_not_null($error))
				{
					$payment_error_return = 'payment_error=' . $this->code . '&error=' . $error;
			    tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
			  }
			}
		}
		
		function get_error()
		{
			global $HTTP_GET_VARS, $cart;

			if (isset($HTTP_GET_VARS['error']))
			{ if ($HTTP_GET_VARS['error'] == 'current_sub')
				{
					$title = FX_PRIOR_SUB_TITLE;
					$error = FX_PRIOR_SUB_TEXT;
				}
				elseif ($HTTP_GET_VARS['error'] == 'exceeded')
				{
					$title = FX_DWNLDS_EXC_TITLE;
					$error = FX_DWNLDS_EXC_TEXT;
				}
				elseif ($HTTP_GET_VARS['error'] == 'dwnld_free')
				{
					$title = FX_DWNLDS_AVAL_TITLE;
					$error = FX_DWNLDS_AVAL_TEXT;
				}							
					$error_array = array(	'title' => $title,
																'error' => $error);
				$cart->reset(true);
			  return $error_array;
			}
		}	
	}
	$subscription = new subscription_product;
?>